### Class

# FwupdPlugin UsbInterface

#### Description [src]

    final class FwupdPlugin.UsbInterface : FwupdPlugin.UsbDescriptor
      implements Fwupd.Codec {
      /* No available fields */
    }

This object is a thin glib wrapper around a libusb_interface_descriptor.

All the data is copied when the object is created and the original descriptor can be destroyed any at point.

#### Ancestors

- FuUsbDescriptor
- FuFirmware
- GObject

#### Implements

- FwupdCodec

#### Constructors

###### fu_usb_interface_new

No description available.

since: 2.0.0

#### Instance methods

###### fu_usb_interface_add_endpoint

No description available.

###### fu_usb_interface_get_alternate

Gets the alternate setting for the interface.

since: 2.0.0

###### fu_usb_interface_get_class

Gets the interface class, typically a `FuUsbInterfaceClassCode`.

since: 2.0.0

###### fu_usb_interface_get_endpoints

Gets interface endpoints.

since: 2.0.0

###### fu_usb_interface_get_index

Gets the index for the string descriptor.

since: 2.0.0

###### fu_usb_interface_get_number

Gets the interface number.

since: 2.0.0

###### fu_usb_interface_get_protocol

Gets the interface protocol qualified by the class and subclass numbers. See `fu_usb_interface_get_class()` and fu_usb_interface_get_subclass().

since: 2.0.0

###### fu_usb_interface_get_subclass

Gets the interface subclass qualified by the class number. See fu_usb_interface_get_class().

since: 2.0.0

##### Methods inherited from FuFirmware (66)

Please see FuFirmware for a full list of methods.

##### Methods inherited from GObject (43)

Please see GObject for a full list of methods.

##### Methods inherited from FwupdCodec (8)

###### fwupd_codec_add_string

Converts an object that implements `FwupdCodec` to a debug string, appending it to `str`.

###### fwupd_codec_from_json

Converts an object that implements `FwupdCodec` from a JSON object.

###### fwupd_codec_from_json_string

Converts an object that implements `FwupdCodec` from a JSON string.

###### fwupd_codec_from_variant

Converts an object that implements `FwupdCodec` from a `GVariant` value.

###### fwupd_codec_to_json

Converts an object that implements `FwupdCodec` to a JSON builder object.

###### fwupd_codec_to_json_string

Converts an object that implements `FwupdCodec` to a JSON string.

###### fwupd_codec_to_string

Converts an object that implements `FwupdCodec` to a debug string.

###### fwupd_codec_to_variant

Converts an object that implements `FwupdCodec` to a `GVariant`.

#### Properties

##### Properties inherited from FuFirmware (1)

###### FwupdPlugin.Firmware:parent

The firmware parent.

since: 1.8.2

#### Signals

##### Signals inherited from GObject (1)

###### GObject::notify

The notify signal is emitted on an object when one of its properties has its value set through g_object_set_property(), g_object_set(), et al.

#### Class structure

    struct FwupdPluginUsbInterfaceClass {
      FuUsbDescriptorClass parent_class;

    }

No description available.

###### Class members

`parent_class: FuUsbDescriptorClass`

  No description available.